<!--
 Copyright © VNG Realisatie 2024
 Licensed under the EUPL
-->

{{ define "content" }}
    <script>
        document.body.addEventListener("htmx:beforeSwap", function (evt) {
            if (
                evt.detail.xhr.status === 400 ||
                evt.detail.xhr.status === 500
            ) {
                evt.detail.shouldSwap = true;
                evt.detail.isError = false;
            }
        });
    </script>

    <div class="connect-to-service-page">
        {{ if ne (len .SuccessMessage) 0 }}
            <div class="alert--success">
                <p class="alert__title">{{ i18n "Success" }}</p>
                <p class="alert__content">{{ .SuccessMessage }}</p>
            </div>
        {{ end }}

        {{ if ne (len .ErrorMessages) 0 }}
            {{ block "errors" . }}
            {{ end }}
        {{ end }}


        <form
            hx-boost="true"
            hx-swap="outerHTML show:window:top"
            action="/services/connection/{{ .Form.ServiceProviderPeerID }}/connect"
            method="post"
            autocomplete="off"
            class="connect-to-service-page__form"
            hx-disabled-elt="button[type=submit]"
        >
            <input
                type="hidden"
                name="csrfToken"
                value="{{ .BaseAuthenticatedPage.CsrfToken }}"
            />
            <datalist id="peerIDs">
                {{ range $peerID, $peer := .PeerIDs }}
                    <option value="{{ $peerID }}" label="{{ $peer }}"></option>
                {{ end }}
            </datalist>

            <datalist id="outway-public-key-thumbprints">
                {{ range $publicKeyThumbprint, $outwayNames := $.OutwayPublicKeyThumbprints }}
                    <option value="{{ $publicKeyThumbprint }}">
                        {{ join $outwayNames }} -
                        {{ $publicKeyThumbprint }}
                    </option>
                {{ end }}
            </datalist>

            <datalist id="service-names">
                {{ range $serviceName := .ServiceNamesForPeer }}
                    <option value="{{ $serviceName }}">
                        {{ $serviceName }}
                    </option>
                {{ end }}
            </datalist>

            <fieldset class="connect-to-service-page__form-actions">
                <button type="submit" class="button--primary">
                    {{ i18n "Connect" }}
                </button>
            </fieldset>

            <fieldset>
                <label>
                    <span>{{ i18n "Service Peer ID" }}</span>
                    {{ if .Form.ServiceProviderPeerID }}
                        <input
                            class="input--large"
                            type="text"
                            name="serviceProviderPeerID"
                            value="{{ .Form.ServiceProviderPeerID }}"
                            readonly
                        />
                    {{ else }}
                        <div class="datalist datalist--medium">
                            <input
                                list="peerIDs"
                                name="serviceProviderPeerID"
                                value="{{ .Form.ServiceProviderPeerID }}"
                            />
                        </div>
                    {{ end }}
                </label>

                <label>
                    <span>{{ i18n "Service Name" }}</span>
                    {{ if .Form.ServiceName }}
                        <input
                            class="input--medium"
                            type="text"
                            name="serviceName"
                            value="{{ .Form.ServiceName }}"
                            readonly
                        />
                    {{ else if .Form.ServiceProviderPeerID }}
                        <div class="datalist datalist--medium">
                            <input
                                list="service-names"
                                name="serviceName"
                                value="{{ .Form.ServiceName }}"
                            />
                        </div>
                    {{ else }}
                        <input
                            class="input--medium"
                            type="text"
                            name="serviceName"
                        />
                    {{ end }}
                </label>

                {{ if .Form.ServiceDelegatorPeerID }}
                    <label>
                        <span>{{ i18n "Service Delegator Peer ID" }}</span>
                        <input
                            class="input--large"
                            type="text"
                            name="serviceDelegatorPeerID"
                            value="{{ .Form.ServiceDelegatorPeerID }}"
                            readonly
                        />
                    </label>
                {{ end }}


                <label>
                    <span>{{ i18n "Delegator Peer ID" }}</span>
                    <small
                        >{{ i18n "Peer ID of the Delegator in case your connecting to this Service on behalf of another Peer." }}</small
                    >
                    <div class="datalist datalist--medium">
                        <input
                            list="peerIDs"
                            name="delegatorPeerID"
                            value="{{ .Form.DelegatorPeerID }}"
                        />
                    </div>
                </label>

                {{ range $i, $thumbprint := $.Form.OutwayPublicKeyThumbprints }}
                    <label>
                        <span>{{ i18n "Outway Public Key Thumbprint" }}</span>
                        <small
                            >{{ i18n "The thumbprint of the Public Key used by the Outway you want to connect" }}</small
                        >
                        <div class="datalist datalist--medium">
                            <input
                                list="outway-public-key-thumbprints"
                                name="outwayPublicKeyThumbprints"
                                id="outwayPublicKeyThumbprints.{{ $i }}"
                                value="{{ $thumbprint }}"
                                required
                                oninvalid="outwayPublicKeyThumbprintOnInvalidHandler(this)"
                                oninput="this.setCustomValidity('')"
                            />
                        </div>
                    </label>
                {{ end }}


                <button
                    class="button--link"
                    name="action"
                    value="{{ .ActionAddOutwayPublicKeyThumbprint }}"
                >
                    {{ svg "icon-plus"
                        "icon--inline"
                    }}

                    {{ i18n "Add" }}
                </button>

                <div class="connect-to-service-page__date-field-wrapper">
                    <label class="connect-to-service-page__date-field">
                        {{ i18n "Valid from" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validFrom"
                            value="{{ .Form.ValidFrom }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>

                    <label class="connect-to-service-page__date-field">
                        {{ i18n "Valid until" }}
                        <input
                            class="input--small"
                            type="date"
                            name="validUntil"
                            value="{{ .Form.ValidUntil }}"
                            placeholder="{{ i18n " yyyy-mm-dd" }}"
                        />
                    </label>
                </div>
            </fieldset>

            <script>
                function outwayPublicKeyThumbprintOnInvalidHandler(el) {
                    if (el.validity.valueMissing) {
                        el.setCustomValidity('{{ i18n "Outway Public Key Thumbprint is required" }}')
                    }
                }
            </script>
        </form>
    </div>
{{ end }}
